// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },
    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    start () {
		this.colorAddBlue = 0;
		
		cc.resources.load('material/spine-test', cc.Material, null, function (error, material) {
			if (error != null) {
				cc.log(error.message);
				return;
			}
			
			cc.resources.load('spine/spineboy', sp.SkeletonData, null, function (error, skeletonData) {
				if (error != null) {
					cc.log(error.message);
					return;
				}
				
				let node = new cc.Node();
				let component = node.addComponent(sp.Skeleton);
				component.skeletonData = skeletonData;
				component.animation = "idle";
				component.loop = true;
				node.scale = 0.36;
				this.node.addChild(node);
				
				let materialTest = cc.MaterialVariant.create(material);
				component.setMaterial(0, materialTest);
				this.spineMaterial = component.getMaterial(0);
			}.bind(this));
		}.bind(this));
    },

    update (dt) {
		if (this.spineMaterial) {
			this.colorAddBlue += dt;
			if (this.colorAddBlue > 2.0) {
				this.colorAddBlue = 0;
			}
			this.spineMaterial.setProperty('colorAddBlue', this.colorAddBlue);
		}
	},
});
